% GAUSS2D 2-d Gaussian PDF
%
%Inputs:
% x1 - 1xN vector - range of x1 component
% x2 - 1xM vector - range of x2 component
% Mu - 2x1 vector - the mean of the random variable
% Sigma - 2x2 Matrix - the variance matrix of the random variable
%
%Outputs:
% Y - NxM matrix - the pdf for the range of x1, x2
%
%Usage (Example):
% Y = Gauss2d([-3:-0.1:3], [0:-0.1:6], [0,3]',[1 1; 1 4])

function Y = Gauss2d( x1, x2, Mu, Sigma)

x1_len = length(x1); % Oh hell yeah, I'm optimizing the crap out of this!
x2_len = length(x2);
sig_det = det(Sigma);
sig_inv = inv(Sigma);


Y = zeros( length(x2), length(x1) );

for i=1:x1_len
    for j=1:x2_len
        v = [x1(i);x2(j)];
        Y(j, i) = 1/(2*pi*sig_det^(1/2))*exp(-0.5*(v-Mu)'*sig_inv*(v-Mu));
    end
end
Y = Y./max(max(Y));