from ca.nengo.util import VectorGenerator
from ca.nengo.model.nef.impl import NEFEnsembleFactoryImpl
from ca.nengo.model.neuron.impl import LIFNeuronFactory
from ca.nengo.math.impl import IndicatorPDF

tauRC = 0.2
tauRef = 0.001
tauPSC = 0.1
maxRateLow = 200
maxRateHigh = 500
interceptLow = -1
interceptHigh = 1

class myGenVectors(VectorGenerator):
    def __init__(self, values):
        self.values = values

    def genVectors(self, num, dim):
        return self.values

class IntegralGenVectors(VectorGenerator):
    def __init__(self, values):
        self.values = values
    
    def genVectors(self, num, dim):
        return self.values

infile = open("N:/My Documents/MATLAB/encvec.csv",'r') # Change this to point at your csv of vectors, where each row is a vector.  
values = []

dimension = 0
for line in infile:
    vals = map(float,line.split(',')) # Read line from csv, split up vector components, convert to float
    if not dimension:
        dimension = len(vals)
    else:
        if len(vals) != dimension:
            print "Your CSV file has strange vector dimensions!"
    values.append(vals)

number = len(values)

infile2 = open("N:/My Documents/MATLAB/points.csv",'r') # Change this to point at your csv of vectors, where each row is a vector. 
x = []
for line in infile2:
    vals = map(float,line.split(',')) # Read line from csv, split up vector components, convert to float
    x.append(vals)


m = myGenVectors(values) # Instantiate our GenVectors class
pe = IntegralGenVectors(x)

ipRate = IndicatorPDF(maxRateLow, maxRateHigh)
ipIntercept = IndicatorPDF(interceptLow, interceptHigh)
nf = LIFNeuronFactory(tauRC, tauRef, ipRate, ipIntercept)

N = NEFEnsembleFactoryImpl() # Create new NEFEnsemble.  I think it just uses default values for tau_RC and tau_REF, and max firing rates etc.
N.setEncoderFactory(m)  # Use our GenVectors factory
N.setNodeFactory(nf)
N.setEvalPointFactory(pe)
NE = N.make("Integrator", number, dimension)  # Change "stuff" to the name of your desired NEFEnsemble
Test.addNode(NE)  # "Test" is the name of the Network the NEFEnsemble is being added to.
infile.close()
infile2.close()

transformInput = [None]*dimension
transformFeedback = [None]*dimension
for i in range(dimension):
     transformInput[i] = [0] * dimension
     transformFeedback[i] = [0] * dimension
     transformInput[i][i] = 1
     transformFeedback[i][i] = 1

Test.getNode("Integrator").addDecodedTermination("input",transformInput,tauPSC,False)
Test.getNode("Integrator").addDecodedTermination("feedback",transformFeedback,tauPSC,False)

