clear all
close all
dim = 2;

x = [-1:0.05:1];

load memblend2D
load 2Dbasis
orimemframe = reshape(mem,length(x),length(x));
orimem = max(orimemframe,[],dim);
orimem = orimem(length(orimem):-1:1);

load blend2D
load recblend2D
t = length(data_time);
figure
recmemframe = reshape(sum(repmat(A,length(x)^2,1).*basis,2),length(x),length(x));
recmem = max(recmemframe,[],dim);
recmem = recmem(length(recmem):-1:1);
frame0 = reshape(sum(repmat(data(1000,:).*norm(A),length(x)^2,1).*basis,2),length(x),length(x));
frame1 = reshape(sum(repmat(data(5000,:).*norm(A),length(x)^2,1).*basis,2),length(x),length(x));
frame2 = reshape(sum(repmat(data(10000,:).*norm(A),length(x)^2,1).*basis,2),length(x),length(x));
memmem0 = max(frame0,[],dim);
memmem0 = memmem0(length(recmem):-1:1);
memmem1 = max(frame1,[],dim);
memmem1 = memmem1(length(recmem):-1:1);
memmem2 = max(frame2,[],dim);
memmem2 = memmem2(length(recmem):-1:1);
step = 50;
i = 1;
for k = 1:step:t
    frame = reshape(sum(repmat(data(k,:).*norm(A),length(x)^2,1).*basis,2),length(x),length(x));
    slice = max(frame,[],dim);
    slice = slice(length(slice):-1:1);
    if k>5000
        plot(x,orimem,'-m',x,recmem,'-g',x,memmem0,'-k',x,memmem1,':r',x,slice,'-b');
    elseif k>1000
            plot(x,orimem,'-m',x,recmem,'-g',x,memmem0,'-k',x,slice,'-b');
    else
        plot(x,orimem,'-m',x,recmem,'-g',x,slice,'-b');
    end
    title('2D Memory Storage');
    xlabel('input');
    ylabel('f(input)');
    axis([-1 1 0 1]);
    M(i) = getframe;
    i = i+1;
end
legend('Original Memory','Memory, 20 dim Projection','Stored Memory','0.5 seconds','1 second','Location','SouthWest');

% error = zeros(9000,1);
% for i=1000:10000
%     error(i-999) = mean((recmem-sum(repmat(data(i,:),length(x),1).*basis,2)).^2);
% end
% figure;
% plot(error.^0.5);
% title('Memory Storage Error');
% xlabel('Time');
% ylabel('RMS');