clear all;
N = 1089;
Nbasis = 100;
dx = 0.05;
x = (-1:dx:1);
dim = 20;
limit = 1;

%Create encoding vectors
centres = -limit + 2*limit*rand(N,1);
width = 0.02;
gs = exp(-0.5*((repmat(x,N,1)+repmat(centres,1,length(x))).^2./repmat(width,N,length(x))));

%Create possible memories
stepM = 0.0355;
widthM = width*2;
memcentres = (-0.9:stepM:0.9);
Nmems = length(memcentres);
mems = exp(-0.5*((repmat(x,Nmems,1)+repmat(memcentres',1,length(x))).^2./repmat(widthM,Nmems,length(x))));
allpeakmems = [mems;mems.*0.8;mems.*0.6;mems.*0.4];
mem = (allpeakmems(6,:)+allpeakmems(26,:)+allpeakmems(46,:));

%Create basis vectors
centresN = (-limit:0.02:limit);
widthB = width/2;
peaks = rand(length(centresN),1);
bfire = 0.8*rand(length(centresN),1);
gbasis = exp(-0.5*((repmat(x,length(centresN),1)+repmat(centresN',1,length(x))).^2./widthB));

%Get basis from performing SVD
b = orth(gbasis');
basis = b(:,1:dim);

%Create encoding points
Npoints = 10000;
MemEvalPoints = allpeakmems*basis;
EvalPointsNorm = MemEvalPoints./repmat(sum(MemEvalPoints.^2,2).^0.5,1,dim);
maxEval = max(EvalPointsNorm);
minEval = min(EvalPointsNorm);
BWpoints = repmat(minEval,Npoints,1) + rand(Npoints,dim).*repmat(maxEval-minEval,Npoints,1);
BWpoints = [BWpoints;zeros(1,dim)];
allpoints = [BWpoints;EvalPointsNorm];

%Project encoding vectors and memory on to basis
EncVec = gs*basis;
A = mem*basis;

%Normalize the encoding vectors and the memory
EncVecNorm = EncVec./repmat(sum(EncVec.^2,2).^0.5,1,dim);
ANorm = A./norm(A);

%write both to CSV files
csvwrite('encvec.csv',EncVecNorm);
csvwrite('points.csv',allpoints);
csvwrite('coeffs.csv',ANorm);

recmem = sum(repmat(A,length(x),1).*basis,2);