clear all;
N = 1089;
Nbasis = 100;
dx = 0.05;
x = (-1:dx:1);
xl = length(x);
dim = 40;
limit = 1;

%Create encoding vectors
centres = -limit + 2*limit*rand(N,1);
step = 1.8/(sqrt(N)-1);
width = 0.02;
p = 1;
G2Df = zeros(N,xl^2);
for i=[-0.9:step:0.9]
    for j=[-0.9:step:0.9]
        G2D = Gauss2d(x,x, [i;j], [width 0;0 width]);
        G2Df(p,:) = reshape(G2D, 1, xl^2);
        p = p + 1;
    end
end
memory
%Create possible memories
stepM = 0.0355;
widthM = width*2;
Nm = ((length([-0.9:stepM:0.9]))^2);
G2Dm = zeros(Nm,length(x)^2);
p = 1;
for i=[-0.9:stepM:0.9]
    for j=[-0.9:stepM:0.9]
        G2D = Gauss2d(x,x, [i;j], [widthM 0;0 widthM]);
        G2Dm(p,:) = reshape(G2D, 1, numel(G2D));
        p = p + 1;
    end
end
memory
G2Dm = [G2Dm;G2Dm.*0.8;G2Dm.*0.6];

mem = G2Dm(312,:)+G2Dm(332,:)+G2Dm(352,:);
mem = mem+G2Dm(1332,:)+G2Dm(1352,:)+G2Dm(1372,:);
mem = mem+G2Dm(2352,:)+G2Dm(2372,:)+G2Dm(2392,:);

%Create basis vectors
stepB = dx;
widthB = width/2;
Nb = ((1.8/stepB+1)^2);
G2Db = zeros(Nb,length(x)^2);
p = 1;
for i=[-0.9:stepB:0.9]
    for j=[-0.9:stepB:0.9]
        peak = rand(1);
        bfire = 0.8*rand(1);
        twidth = widthB+rand(1)*2*widthB;
        G2D = repmat(bfire,41,41)+repmat(peak,41,41).*Gauss2d(x,x, [i;j], [twidth 0;0 twidth]);
        G2Db(p,:) = reshape(G2D, 1, numel(G2D));
        p = p + 1;
    end
end

%Get basis from performing SVD
b = orth(G2Db');
basis = b(:,1:dim);

%Create encoding points
Npoints = 10000;
MemEvalPoints = G2Dm*basis;
EvalPointsNorm = MemEvalPoints./repmat(sum(MemEvalPoints.^2,2).^0.5,1,dim);
maxEval = max(EvalPointsNorm);
minEval = min(EvalPointsNorm);
BWpoints = repmat(minEval,Npoints,1) + rand(Npoints,dim).*repmat(maxEval-minEval,Npoints,1);
BWpoints = [BWpoints;zeros(1,dim)];
allpoints = [BWpoints;EvalPointsNorm];

%Project encoding vectors and memory on to basis
EncVec = G2Df*basis;
A = mem*basis;

%Normalize the encoding vectors and the memory
EncVecNorm = EncVec./repmat(sum(EncVec.^2,2).^0.5,1,dim);
ANorm = A./norm(A);

recmem = sum(repmat(A,length(x).^2,1).*basis,2);

%write both to CSV files
csvwrite('encvec2.csv',EncVecNorm);
csvwrite('points2.csv',allpoints);
csvwrite('coeffs2.csv',ANorm);